FIBTREE - Editorial

Problem link : contest practice

Difficulty : Hard

Pre-requisites : heavy-light decomposition, segment trees, persistence

Solution :

First, let’s recall one of the properties of Fibonacci numbers: the n-th Fibbonacci number is axn+(1-a)yn, where:

  • a equals to (3+sqrt(5))/(5+sqrt(5));
  • x equals to (1+sqrt(5))/2;
  • y equals to (1-sqrt(5))/2.

So, the sum of the first K Fibbonacci numbers is basically the sum of two progressions.

Now there are still two questions:

  1. How do we operate with floating point numbers? How do we avoid the precision loss?
  2. How do we add the geometric progression on a segment?

The answer to the first quesion is: we don’t operate with floating point numbers/doubles at all. This can be achieved this way: since our modulo 1000000009 is a prime, we can find such integer T that its’ square modulo 1000000009 is 5. This way we can define sqrt(5) in the modulo ring. Now we have that sqrt(5) is an integer, so all the operations become ordinary modular arithmetic operations.

Now we can have a segment tree for the progressions addition. Here is the tutorial on developing such kind of segment trees.

When we have a segment tree, it’s time to make in persistent and to build the heavy-light decomposition of the tree. Pay attention that if you store all the chains of the HLD in the single segment tree, there is no more effort required to maintain the versions of the persistence correctly. But if not, you’ll also have to store some persistent array to get access to the right version of some exact chain. Here is the detailed desription of persistent heavy-light decomposition’s implementation.

Setter’s solution: link

Tester’s solution: link

5 Likes

There is another easy way to update the Segment Tree with the Fibonacci series. Define a new sequence G such that G(1)=F(a)+F(b)+F©… for all a,b,c… such that a,b,c are all the starting terms of the sequence added. Similarly for G(2). Clearly G(3)=G(2)+G(1) (The Fibonacci relation still holds.) This can be used to generate the sequence using matrix exponentiation or precomputation.

1 Like

How do you answer to “sum over subtree” query in your solution? The way I know about requires one more segment tree, can you do it somehow easier?

There are many other approaches for this problem.

thanks for making good question :slight_smile:

It can be done in the same way. Maintain another attribute in the segment tree node where instead of a value of F(a) for a node, we will have F(a) + F(b) + F© + …F(x) where x is the deepest node in the path, that the current node is a parent of. This can be expressed again in terms of Fibonacci numbers. Solve accordingly.

Did anyone do this by flattening out the tree following an Euler tour + persistent segment trees? I’m trying to do this and whatever I try, I always get one of these two problems if i try to get rid of the other

  • Root about a vertex and subtree-sum shoots to \mathcal O(N)
  • Or the propagation shoots to \mathcal O(N) (lazy propagation isn’t possible)

I’ll appreciate if someone can help me. Thanks.